Exécuter une macro à tous les composants d'un assemblage

Bonjour à tous,

Je souhaiterais appliquer une macro qui modifie les unités de toutes les pièces d'un assemblage (voir d'un dossier) sans avoir à les ouvrir une par une.

J'ai déjà le code pour la modification des unités mais il me manque la partie pour l'appliquer à tous les éléments d'un assemblage (pièces essentiellement).

Quelqu'un saurait-il m'aiguiller?

 


change_unites.swp

Regarde cette macro qui traverse un assemblage de part en part en part:

 

 '--------------------------------------------------------------------------
' Preconditions:
' 1. Open an assembly document containing nested subassemblies.
' 2. Open the Immediate window.
'
' Postconditions:
' 1. Traverses the assembly.
' 2. Examine the Immediate window.
'---------------------------------------------------------------------------

Option Explicit

Sub TraverseFeatureFeatures(swFeat As SldWorks.Feature, nLevel As Long)

    Dim swSubFeat                   As SldWorks.Feature
    Dim swSubSubFeat                As SldWorks.Feature
    Dim swSubSubSubFeat             As SldWorks.Feature
    Dim sPadStr                     As String
    Dim i                           As Long

    For i = 0 To nLevel
        sPadStr = sPadStr + "  "
    Next i

    While Not swFeat Is Nothing
        If swFeat.GetTypeName = "Reference" Then
        Debug.Print "0:" + sPadStr + swFeat.Name + " [" + swFeat.GetTypeName + "]"
        End If
        Set swSubFeat = swFeat.GetFirstSubFeature
        While Not swSubFeat Is Nothing
            Debug.Print "1:" + sPadStr + "  " + swSubFeat.Name + " [" + swSubFeat.GetTypeName + "]"

            Set swSubSubFeat = swSubFeat.GetFirstSubFeature
            While Not swSubSubFeat Is Nothing
                Debug.Print "2:" + sPadStr + "    " + swSubSubFeat.Name + " [" + swSubSubFeat.GetTypeName + "]"

                Set swSubSubSubFeat = swSubSubFeat.GetFirstSubFeature
                While Not swSubSubSubFeat Is Nothing
                    Debug.Print "3:" + sPadStr + "      " + swSubSubSubFeat.Name + " [" + swSubSubSubFeat.GetTypeName + "]"

                    Set swSubSubSubFeat = swSubSubSubFeat.GetNextSubFeature()

                Wend

                Set swSubSubFeat = swSubSubFeat.GetNextSubFeature()

            Wend

            Set swSubFeat = swSubFeat.GetNextSubFeature()

        Wend

        Set swFeat = swFeat.GetNextFeature

    Wend

End Sub

Sub TraverseComponentFeatures(swComp As SldWorks.Component2, nLevel As Long)

    Dim swFeat As SldWorks.Feature

    Set swFeat = swComp.FirstFeature
    TraverseFeatureFeatures swFeat, nLevel

End Sub


Sub TraverseComponent(swComp As SldWorks.Component2, nLevel As Long)

    Dim vChildComp                  As Variant
    Dim swChildComp                 As SldWorks.Component2
    Dim sPadStr                     As String
    Dim i                           As Long
    

    For i = 0 To nLevel - 1
        sPadStr = sPadStr + "  "
    Next i

    vChildComp = swComp.GetChildren
    For i = 0 To UBound(vChildComp)
        Set swChildComp = vChildComp(i)

        Debug.Print sPadStr & "+" & swChildComp.Name2 & " <" & swChildComp.ReferencedConfiguration & ">"

        TraverseComponentFeatures swChildComp, nLevel
        TraverseComponent swChildComp, nLevel + 1

    Next i

End Sub

Sub TraverseModelFeatures(swModel As SldWorks.ModelDoc2, nLevel As Long)

    Dim swFeat As SldWorks.Feature

    Set swFeat = swModel.FirstFeature
    TraverseFeatureFeatures swFeat, nLevel

End Sub

Sub main()

    Dim swApp                       As SldWorks.SldWorks
    Dim swModel                     As SldWorks.ModelDoc2
    Dim swConfMgr                   As SldWorks.ConfigurationManager
    Dim swConf                      As SldWorks.Configuration
    Dim swRootComp                  As SldWorks.Component2
    Dim StartTime                   As Double
    Dim FinishTime                  As Double
    Dim TotalTime                   As Double
    

    Set swApp = CreateObject("SldWorks.Application")
    Set swModel = swApp.ActiveDoc
    Set swConfMgr = swModel.ConfigurationManager
    Set swConf = swConfMgr.ActiveConfiguration
    Set swRootComp = swConf.GetRootComponent3(True)

    StartTime = Timer ' Start time

    Debug.Print "File = " & swModel.GetPathName

    TraverseModelFeatures swModel, 1

    If swModel.GetType = SwConst.swDocASSEMBLY Then
        TraverseComponent swRootComp, 1

    End If

    FinishTime = Timer ' End time
    TotalTime = FinishTime - StartTime ' Elapsed time
    Debug.Print ("Time = " & TotalTime & " sec")
    

End Sub

Elle t'affiche le nom de chaque pièce, assemblage, et même fonction de l'assemblage principale.

Il te suffit ensuite grâce au nom ou au chemin à ouvrir la pièce demandé appliqué ton code, l'enregistrer et la fermer.

Pour d'autre exemple fait une recherche avec macro solidworks et traverse components.

EDIT: Et la version API SW:

https://help.solidworks.com/2020/english/api/sldworksapi/Traverse_Assembly_at_Component_and_Feature_Level_Example_VB.htm?verRedirect=1

1 « J'aime »

2 trois autre exemple en vrac:

https://stackoverflow.com/questions/60000471/saving-all-parts-in-an-assembly-as-step-with-custom-properties-how-to-solve-run

https://r1132100503382-eu1-3dswym.3dexperience.3ds.com/#community:yUw32GbYTEqKdgY7-jbZPg/iquestion:6lAv8HurTReoBjJqUe3xIg

 

Bonjour,

Sinon vous pouvez le faire sans code avec l'outil integration de myCADtools  :

L'aide sur Integration : https://help.visiativ.com/mycadtools/2022/fr/Integration.html

Opération pour lancer une macro : https://help.visiativ.com/mycadtools/2022/fr/Integration186.html

Vous pouvez test myCADtools pendant 30 jours si vous n'avez pas d'abonnement myCADservices Premium : https://www.lynkoa.com/mycadtools

Bonne journée 

Philippe